diff --git a/headers/build/os/support/SupportDefs.h b/headers/build/os/support/SupportDefs.h
index f400fd3..e0f898d 100644
--- a/headers/build/os/support/SupportDefs.h
+++ b/headers/build/os/support/SupportDefs.h
@@ -1,2 +1,266 @@
+/*
+ * Copyright 2004-2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ *
+ * Author:
+ *		Erik Jaesler (erik@cgsoftware.com)
+ */
+#ifndef _HAIKU_BUILD_SUPPORT_DEFS_H
+#define _HAIKU_BUILD_SUPPORT_DEFS_H
+
+
 #include <config_build/types.h>
-#include <../os/support/SupportDefs.h>
+
+#include <BeBuild.h>
+#include <Errors.h>
+
+#include <inttypes.h>
+#include <sys/types.h>
+
+
+/* fixed-size integer types */
+typedef	__haiku_build_haiku_int8			haiku_build_int8;
+typedef __haiku_build_haiku_uint8			haiku_build_uint8;
+typedef	__haiku_build_haiku_int16			haiku_build_int16;
+typedef __haiku_build_haiku_uint16			haiku_build_uint16;
+typedef	__haiku_build_haiku_int32			haiku_build_int32;
+typedef __haiku_build_haiku_uint32			haiku_build_uint32;
+typedef	__haiku_build_haiku_int64			haiku_build_int64;
+typedef __haiku_build_haiku_uint64			haiku_build_uint64;
+
+/* shorthand types */
+typedef volatile haiku_build_int8   		haiku_build_vint8;
+typedef volatile haiku_build_uint8			haiku_build_vuint8;
+typedef volatile haiku_build_int16			haiku_build_vint16;
+typedef volatile haiku_build_uint16			haiku_build_vuint16;
+typedef volatile haiku_build_int32			haiku_build_vint32;
+typedef volatile haiku_build_uint32			haiku_build_vuint32;
+typedef volatile haiku_build_int64			haiku_build_vint64;
+typedef volatile haiku_build_uint64			haiku_build_vuint64;
+
+typedef volatile long			haiku_build_vlong;
+typedef volatile int			haiku_build_vint;
+typedef volatile short			haiku_build_vshort;
+typedef volatile char			haiku_build_vchar;
+
+typedef volatile unsigned long	haiku_build_vulong;
+typedef volatile unsigned int	haiku_build_vuint;
+typedef volatile unsigned short	haiku_build_vushort;
+typedef volatile unsigned char	haiku_build_vuchar;
+
+typedef unsigned char			haiku_build_uchar;
+typedef unsigned short          haiku_build_unichar;
+
+/* descriptive types */
+typedef haiku_build_int32		haiku_build_status_t;
+typedef haiku_build_int64		haiku_build_bigtime_t;
+typedef haiku_build_int64		haiku_build_nanotime_t;
+typedef haiku_build_uint32		haiku_build_type_code;
+typedef haiku_build_uint32		haiku_build_perform_code;
+
+typedef __haiku_build_haiku_phys_addr_t		haiku_build_phys_addr_t;
+typedef haiku_build_phys_addr_t				haiku_build_phys_size_t;
+
+typedef	__haiku_build_haiku_generic_addr_t	haiku_build_generic_addr_t;
+typedef	haiku_build_generic_addr_t			haiku_build_generic_size_t;
+
+
+/* printf()/scanf() format strings for [u]int* types */
+#define HAIKU_BUILD_B_PRId8			"d"
+#define HAIKU_BUILD_B_PRIi8			"i"
+#define HAIKU_BUILD_B_PRId16		"d"
+#define HAIKU_BUILD_B_PRIi16		"i"
+#define HAIKU_BUILD_B_PRId32		__HAIKU_BUILD_HAIKU_PRI_PREFIX_32 "d"
+#define HAIKU_BUILD_B_PRIi32		__HAIKU_BUILD_HAIKU_PRI_PREFIX_32 "i"
+#define HAIKU_BUILD_B_PRId64		__HAIKU_BUILD_HAIKU_PRI_PREFIX_64 "d"
+#define HAIKU_BUILD_B_PRIi64		__HAIKU_BUILD_HAIKU_PRI_PREFIX_64 "i"
+#define HAIKU_BUILD_B_PRIu8			"u"
+#define HAIKU_BUILD_B_PRIo8			"o"
+#define HAIKU_BUILD_B_PRIx8			"x"
+#define HAIKU_BUILD_B_PRIX8			"X"
+#define HAIKU_BUILD_B_PRIu16		"u"
+#define HAIKU_BUILD_B_PRIo16		"o"
+#define HAIKU_BUILD_B_PRIx16		"x"
+#define HAIKU_BUILD_B_PRIX16		"X"
+#define HAIKU_BUILD_B_PRIu32		__HAIKU_BUILD_HAIKU_PRI_PREFIX_32 "u"
+#define HAIKU_BUILD_B_PRIo32		__HAIKU_BUILD_HAIKU_PRI_PREFIX_32 "o"
+#define HAIKU_BUILD_B_PRIx32		__HAIKU_BUILD_HAIKU_PRI_PREFIX_32 "x"
+#define HAIKU_BUILD_B_PRIX32		__HAIKU_BUILD_HAIKU_PRI_PREFIX_32 "X"
+#define HAIKU_BUILD_B_PRIu64		__HAIKU_BUILD_HAIKU_PRI_PREFIX_64 "u"
+#define HAIKU_BUILD_B_PRIo64		__HAIKU_BUILD_HAIKU_PRI_PREFIX_64 "o"
+#define HAIKU_BUILD_B_PRIx64		__HAIKU_BUILD_HAIKU_PRI_PREFIX_64 "x"
+#define HAIKU_BUILD_B_PRIX64		__HAIKU_BUILD_HAIKU_PRI_PREFIX_64 "X"
+
+#define HAIKU_BUILD_B_SCNd8 		"hhd"
+#define HAIKU_BUILD_B_SCNi8 		"hhi"
+#define HAIKU_BUILD_B_SCNd16		"hd"
+#define HAIKU_BUILD_B_SCNi16	 	"hi"
+#define HAIKU_BUILD_B_SCNd32 		__HAIKU_BUILD_HAIKU_PRI_PREFIX_32 "d"
+#define HAIKU_BUILD_B_SCNi32	 	__HAIKU_BUILD_HAIKU_PRI_PREFIX_32 "i"
+#define HAIKU_BUILD_B_SCNd64		__HAIKU_BUILD_HAIKU_PRI_PREFIX_64 "d"
+#define HAIKU_BUILD_B_SCNi64 		__HAIKU_BUILD_HAIKU_PRI_PREFIX_64 "i"
+#define HAIKU_BUILD_B_SCNu8 		"hhu"
+#define HAIKU_BUILD_B_SCNo8 		"hho"
+#define HAIKU_BUILD_B_SCNx8 		"hhx"
+#define HAIKU_BUILD_B_SCNu16		"hu"
+#define HAIKU_BUILD_B_SCNo16		"ho"
+#define HAIKU_BUILD_B_SCNx16		"hx"
+#define HAIKU_BUILD_B_SCNu32 		__HAIKU_BUILD_HAIKU_PRI_PREFIX_32 "u"
+#define HAIKU_BUILD_B_SCNo32 		__HAIKU_BUILD_HAIKU_PRI_PREFIX_32 "o"
+#define HAIKU_BUILD_B_SCNx32 		__HAIKU_BUILD_HAIKU_PRI_PREFIX_32 "x"
+#define HAIKU_BUILD_B_SCNu64		__HAIKU_BUILD_HAIKU_PRI_PREFIX_64 "u"
+#define HAIKU_BUILD_B_SCNo64		__HAIKU_BUILD_HAIKU_PRI_PREFIX_64 "o"
+#define HAIKU_BUILD_B_SCNx64		__HAIKU_BUILD_HAIKU_PRI_PREFIX_64 "x"
+
+/* printf() format strings for some standard types */
+/* size_t */
+#define HAIKU_BUILD_B_PRIuSIZE		__HAIKU_BUILD_HAIKU_PRI_PREFIX_ADDR "u"
+#define HAIKU_BUILD_B_PRIoSIZE		__HAIKU_BUILD_HAIKU_PRI_PREFIX_ADDR "o"
+#define HAIKU_BUILD_B_PRIxSIZE		__HAIKU_BUILD_HAIKU_PRI_PREFIX_ADDR "x"
+#define HAIKU_BUILD_B_PRIXSIZE		__HAIKU_BUILD_HAIKU_PRI_PREFIX_ADDR "X"
+/* ssize_t */
+#define HAIKU_BUILD_B_PRIdSSIZE		__HAIKU_BUILD_HAIKU_PRI_PREFIX_ADDR "d"
+#define HAIKU_BUILD_B_PRIiSSIZE		__HAIKU_BUILD_HAIKU_PRI_PREFIX_ADDR "i"
+/* addr_t */
+#define HAIKU_BUILD_B_PRIuADDR		__HAIKU_BUILD_HAIKU_PRI_PREFIX_ADDR "u"
+#define HAIKU_BUILD_B_PRIoADDR		__HAIKU_BUILD_HAIKU_PRI_PREFIX_ADDR "o"
+#define HAIKU_BUILD_B_PRIxADDR		__HAIKU_BUILD_HAIKU_PRI_PREFIX_ADDR "x"
+#define HAIKU_BUILD_B_PRIXADDR		__HAIKU_BUILD_HAIKU_PRI_PREFIX_ADDR "X"
+/* phys_addr_t */
+#define HAIKU_BUILD_B_PRIuPHYSADDR	__HAIKU_BUILD_HAIKU_PRI_PREFIX_PHYS_ADDR "u"
+#define HAIKU_BUILD_B_PRIoPHYSADDR	__HAIKU_BUILD_HAIKU_PRI_PREFIX_PHYS_ADDR "o"
+#define HAIKU_BUILD_B_PRIxPHYSADDR	__HAIKU_BUILD_HAIKU_PRI_PREFIX_PHYS_ADDR "x"
+#define HAIKU_BUILD_B_PRIXPHYSADDR	__HAIKU_BUILD_HAIKU_PRI_PREFIX_PHYS_ADDR "X"
+/* generic_addr_t */
+#define HAIKU_BUILD_B_PRIuGENADDR	\
+	__HAIKU_BUILD_HAIKU_PRI_PREFIX_GENERIC_ADDR "u"
+#define HAIKU_BUILD_B_PRIoGENADDR	\
+	__HAIKU_BUILD_HAIKU_PRI_PREFIX_GENERIC_ADDR "o"
+#define HAIKU_BUILD_B_PRIxGENADDR	\
+	__HAIKU_BUILD_HAIKU_PRI_PREFIX_GENERIC_ADDR "x"
+#define HAIKU_BUILD_B_PRIXGENADDR	\
+	__HAIKU_BUILD_HAIKU_PRI_PREFIX_GENERIC_ADDR "X"
+/* off_t */
+#define HAIKU_BUILD_B_PRIdOFF		HAIKU_BUILD_B_PRId64
+#define HAIKU_BUILD_B_PRIiOFF		HAIKU_BUILD_B_PRIi64
+/* dev_t */
+#define HAIKU_BUILD_B_PRIdDEV		HAIKU_BUILD_B_PRId32
+#define HAIKU_BUILD_B_PRIiDEV		HAIKU_BUILD_B_PRIi32
+/* ino_t */
+#define HAIKU_BUILD_B_PRIdINO		HAIKU_BUILD_B_PRId64
+#define HAIKU_BUILD_B_PRIiINO		HAIKU_BUILD_B_PRIi64
+/* time_t */
+#define HAIKU_BUILD_B_PRIdTIME		HAIKU_BUILD_B_PRId32
+#define HAIKU_BUILD_B_PRIiTIME		HAIKU_BUILD_B_PRIi32
+
+
+/* Empty string ("") */
+#ifdef __cplusplus
+extern const char *HAIKU_BUILD_B_EMPTY_STRING;
+#endif
+
+
+/* min and max comparisons */
+#ifndef __cplusplus
+#	ifndef haiku_build_min
+#		define haiku_build_min(a,b) ((a)>(b)?(b):(a))
+#	endif
+#	ifndef haiku_build_max
+#		define haiku_build_max(a,b) ((a)>(b)?(a):(b))
+#	endif
+#endif
+
+/* min() and max() are functions in C++ */
+#define haiku_build_min_c(a,b) ((a)>(b)?(b):(a))
+#define haiku_build_max_c(a,b) ((a)>(b)?(a):(b))
+
+
+/* Grandfathering */
+#ifndef __cplusplus
+#	include <stdbool.h>
+#endif
+
+/*
+#ifndef HAIKU_BUILD_NULL
+#	define HAIKU_BUILD_NULL (0)
+#endif
+*/
+
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/* Atomic functions; previous value is returned */
+extern haiku_build_int32	haiku_build_atomic_set(haiku_build_vint32 *value,
+								haiku_build_int32 newValue);
+extern haiku_build_int32	haiku_build_atomic_test_and_set(
+								haiku_build_vint32 *value,
+								haiku_build_int32 newValue,
+								haiku_build_int32 testAgainst);
+extern haiku_build_int32	haiku_build_atomic_add(haiku_build_vint32 *value,
+								haiku_build_int32 addValue);
+extern haiku_build_int32	haiku_build_atomic_and(haiku_build_vint32 *value,
+								haiku_build_int32 andValue);
+extern haiku_build_int32	haiku_build_atomic_or(haiku_build_vint32 *value,
+								haiku_build_int32 orValue);
+extern haiku_build_int32	haiku_build_atomic_get(haiku_build_vint32 *value);
+
+extern haiku_build_int64	haiku_build_atomic_set64(haiku_build_vint64 *value,
+								haiku_build_int64 newValue);
+extern haiku_build_int64	haiku_build_atomic_test_and_set64(
+								haiku_build_vint64 *value,
+								haiku_build_int64 newValue,
+								haiku_build_int64 testAgainst);
+extern haiku_build_int64	haiku_build_atomic_add64(haiku_build_vint64 *value,
+								haiku_build_int64 addValue);
+extern haiku_build_int64	haiku_build_atomic_and64(haiku_build_vint64 *value,
+								haiku_build_int64 andValue);
+extern haiku_build_int64	haiku_build_atomic_or64(haiku_build_vint64 *value,
+								haiku_build_int64 orValue);
+extern haiku_build_int64	haiku_build_atomic_get64(haiku_build_vint64 *value);
+
+/* Other stuff */
+extern void*	haiku_build_get_stack_frame(void);
+
+#ifdef __cplusplus
+}
+#endif
+
+/* Obsolete or discouraged API */
+
+/* use 'true' and 'false' */
+#ifndef FALSE
+#	define FALSE	0
+#endif
+#ifndef TRUE
+#	define TRUE		1
+#endif
+
+
+/* Use the built-in atomic functions, if requested and available. */
+
+#if defined(HAIKU_BUILD_B_USE_BUILTIN_ATOMIC_FUNCTIONS) && __GNUC__ >= 4
+
+#define haiku_build_atomic_test_and_set(valuePointer, newValue, testAgainst) \
+	__sync_val_compare_and_swap(valuePointer, testAgainst, newValue)
+#define haiku_build_atomic_add(valuePointer, addValue)	\
+	__sync_fetch_and_add(valuePointer, addValue)
+#define haiku_build_atomic_and(valuePointer, andValue)	\
+	__sync_fetch_and_and(valuePointer, andValue)
+#define haiku_build_atomic_or(valuePointer, orValue)	\
+	__sync_fetch_and_or(valuePointer, orValue)
+#define haiku_build_atomic_get(valuePointer)	\
+	__sync_fetch_and_or(valuePointer, 0)
+	// No equivalent to atomic_get(). We simulate it via atomic or. On most
+	// (all?) 32+ bit architectures aligned 32 bit reads will be atomic anyway,
+	// though.
+
+// Note: No equivalent for atomic_set(). It could be simulated by a
+// get + atomic test and set loop, but calling the atomic_set() implementation
+// might be faster.
+
+#endif	// HAIKU_BUILD_B_USE_BUILTIN_ATOMIC_FUNCTIONS && __GNUC__ >= 4
+
+
+#endif	/* _HAIKU_BUILD_SUPPORT_DEFS_H */
diff --git a/headers/build/posix/alloca.h b/headers/build/posix/alloca.h
new file mode 100644
index 0000000..482e4e9
--- /dev/null
+++ b/headers/build/posix/alloca.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_ALLOCA_H
+#define _HAIKU_BUILD_ALLOCA_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <alloca.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_ALLOCA_H */
diff --git a/headers/build/posix/assert.h b/headers/build/posix/assert.h
new file mode 100644
index 0000000..4e7cf94
--- /dev/null
+++ b/headers/build/posix/assert.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_ASSERT_H
+#define _HAIKU_BUILD_ASSERT_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <assert.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_ASSERT_H */
diff --git a/headers/build/posix/ctype.h b/headers/build/posix/ctype.h
new file mode 100644
index 0000000..2153df7
--- /dev/null
+++ b/headers/build/posix/ctype.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_CTYPE_H
+#define _HAIKU_BUILD_CTYPE_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <ctype.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_CTYPE_H */
diff --git a/headers/build/posix/dirent.h b/headers/build/posix/dirent.h
new file mode 100644
index 0000000..a34a90f
--- /dev/null
+++ b/headers/build/posix/dirent.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_DIRTYPE_H
+#define _HAIKU_BUILD_DIRTYPE_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <dirent.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_DIRTYPE_H */
diff --git a/headers/build/posix/dlfcn.h b/headers/build/posix/dlfcn.h
new file mode 100644
index 0000000..b3fad93
--- /dev/null
+++ b/headers/build/posix/dlfcn.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_DLFCN_H
+#define _HAIKU_BUILD_DLFCN_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <dlfcn.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_DLFCN_H */
diff --git a/headers/build/posix/endian.h b/headers/build/posix/endian.h
new file mode 100644
index 0000000..601b693
--- /dev/null
+++ b/headers/build/posix/endian.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_ENDIAN_H
+#define _HAIKU_BUILD_ENDIAN_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <endian.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_ENDIAN_H */
diff --git a/headers/build/posix/errno.h b/headers/build/posix/errno.h
new file mode 100644
index 0000000..ce58ea7
--- /dev/null
+++ b/headers/build/posix/errno.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_ERRNO_H
+#define _HAIKU_BUILD_ERRNO_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <errno.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_ERRNO_H */
diff --git a/headers/build/posix/fcntl.h b/headers/build/posix/fcntl.h
new file mode 100644
index 0000000..8925ebe
--- /dev/null
+++ b/headers/build/posix/fcntl.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_FCNTL_H
+#define _HAIKU_BUILD_FCNTL_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <fcntl.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_FCNTL_H */
diff --git a/headers/build/posix/fenv.h b/headers/build/posix/fenv.h
new file mode 100644
index 0000000..d1c8655
--- /dev/null
+++ b/headers/build/posix/fenv.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_FENV_H
+#define _HAIKU_BUILD_FENV_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <fenv.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_FENV_H */
diff --git a/headers/build/posix/fnmatch.h b/headers/build/posix/fnmatch.h
new file mode 100644
index 0000000..f6d8cc5
--- /dev/null
+++ b/headers/build/posix/fnmatch.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_FNMATCH_H
+#define _HAIKU_BUILD_FNMATCH_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <fnmatch.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_FNMATCH_H */
diff --git a/headers/build/posix/getopt.h b/headers/build/posix/getopt.h
new file mode 100644
index 0000000..5cbc123
--- /dev/null
+++ b/headers/build/posix/getopt.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_GETOPT_H
+#define _HAIKU_BUILD_GETOPT_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <getopt.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_GETOPT_H */
diff --git a/headers/build/posix/glob.h b/headers/build/posix/glob.h
new file mode 100644
index 0000000..86938dc
--- /dev/null
+++ b/headers/build/posix/glob.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_GLOB_H
+#define _HAIKU_BUILD_GLOB_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <glob.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_GLOB_H */
diff --git a/headers/build/posix/grp.h b/headers/build/posix/grp.h
new file mode 100644
index 0000000..c28cf6a
--- /dev/null
+++ b/headers/build/posix/grp.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_GRP_H
+#define _HAIKU_BUILD_GRP_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <grp.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_GRP_H */
diff --git a/headers/build/posix/inttypes.h b/headers/build/posix/inttypes.h
new file mode 100644
index 0000000..d4ad8f8
--- /dev/null
+++ b/headers/build/posix/inttypes.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_INTTYPES_H
+#define _HAIKU_BUILD_INTTYPES_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <inttypes.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_INTTYPES_H */
diff --git a/headers/build/posix/iovec.h b/headers/build/posix/iovec.h
new file mode 100644
index 0000000..0c360d7
--- /dev/null
+++ b/headers/build/posix/iovec.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_IOVEC_H
+#define _HAIKU_BUILD_IOVEC_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <iovec.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_IOVEC_H */
diff --git a/headers/build/posix/langinfo.h b/headers/build/posix/langinfo.h
new file mode 100644
index 0000000..c9c61f9
--- /dev/null
+++ b/headers/build/posix/langinfo.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_LANGINFO_H
+#define _HAIKU_BUILD_LANGINFO_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <langinfo.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_LANGINFO_H */
diff --git a/headers/build/posix/libgen.h b/headers/build/posix/libgen.h
new file mode 100644
index 0000000..79b89d7
--- /dev/null
+++ b/headers/build/posix/libgen.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_LIBGEN_H
+#define _HAIKU_BUILD_LIBGEN_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <libgen.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_LIBGEN_H */
diff --git a/headers/build/posix/libio.h b/headers/build/posix/libio.h
new file mode 100644
index 0000000..00122ec
--- /dev/null
+++ b/headers/build/posix/libio.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_LIBIO_H
+#define _HAIKU_BUILD_LIBIO_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <libio.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_LIBIO_H */
diff --git a/headers/build/posix/limits.h b/headers/build/posix/limits.h
new file mode 100644
index 0000000..6cee232
--- /dev/null
+++ b/headers/build/posix/limits.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_LIMITS_H
+#define _HAIKU_BUILD_LIMITS_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <limits.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_LIMITS_H */
diff --git a/headers/build/posix/locale.h b/headers/build/posix/locale.h
new file mode 100644
index 0000000..7f5467b
--- /dev/null
+++ b/headers/build/posix/locale.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_LOCALE_H
+#define _HAIKU_BUILD_LOCALE_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <locale.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_LOCALE_H */
diff --git a/headers/build/posix/malloc.h b/headers/build/posix/malloc.h
new file mode 100644
index 0000000..2a4f91f
--- /dev/null
+++ b/headers/build/posix/malloc.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_MALLOC_H
+#define _HAIKU_BUILD_MALLOC_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <malloc.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_MALLOC_H */
diff --git a/headers/build/posix/math.h b/headers/build/posix/math.h
new file mode 100644
index 0000000..a06411e
--- /dev/null
+++ b/headers/build/posix/math.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_MATH_H
+#define _HAIKU_BUILD_MATH_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <math.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_MATH_H */
diff --git a/headers/build/posix/memory.h b/headers/build/posix/memory.h
new file mode 100644
index 0000000..9444237
--- /dev/null
+++ b/headers/build/posix/memory.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_MEMORY_H
+#define _HAIKU_BUILD_MEMORY_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <memory.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_MEMORY_H */
diff --git a/headers/build/posix/monetary.h b/headers/build/posix/monetary.h
new file mode 100644
index 0000000..98f0326
--- /dev/null
+++ b/headers/build/posix/monetary.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_MONETARY_H
+#define _HAIKU_BUILD_MONETARY_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <monetary.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_MONETARY_H */
diff --git a/headers/build/posix/netdb.h b/headers/build/posix/netdb.h
new file mode 100644
index 0000000..fd3002d
--- /dev/null
+++ b/headers/build/posix/netdb.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_NETDB_H
+#define _HAIKU_BUILD_NETDB_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <netdb.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_NETDB_H */
diff --git a/headers/build/posix/nl_types.h b/headers/build/posix/nl_types.h
new file mode 100644
index 0000000..c6ee61e
--- /dev/null
+++ b/headers/build/posix/nl_types.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_NL_TYPES_H
+#define _HAIKU_BUILD_NL_TYPES_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <nl_types.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_NL_TYPES_H */
diff --git a/headers/build/posix/null.h b/headers/build/posix/null.h
new file mode 100644
index 0000000..a71e64c
--- /dev/null
+++ b/headers/build/posix/null.h
@@ -0,0 +1,15 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_NULL_H
+#define _HAIKU_BUILD_NULL_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+// not a standard header.
+//#	include_next <null.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_NULL_H */
diff --git a/headers/build/posix/poll.h b/headers/build/posix/poll.h
new file mode 100644
index 0000000..777f154
--- /dev/null
+++ b/headers/build/posix/poll.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_POLL_H
+#define _HAIKU_BUILD_POLL_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <poll.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_POLL_H */
diff --git a/headers/build/posix/pthread.h b/headers/build/posix/pthread.h
new file mode 100644
index 0000000..645fe08
--- /dev/null
+++ b/headers/build/posix/pthread.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_PTHREAD_H
+#define _HAIKU_BUILD_PTHREAD_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <pthread.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_PTHREAD_H */
diff --git a/headers/build/posix/pwd.h b/headers/build/posix/pwd.h
new file mode 100644
index 0000000..283b505
--- /dev/null
+++ b/headers/build/posix/pwd.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_PWD_H
+#define _HAIKU_BUILD_PWD_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <pwd.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_PWD_H */
diff --git a/headers/build/posix/regex.h b/headers/build/posix/regex.h
new file mode 100644
index 0000000..cc2ccb7
--- /dev/null
+++ b/headers/build/posix/regex.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_REGEX_H
+#define _HAIKU_BUILD_REGEX_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <regex.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_REGEX_H */
diff --git a/headers/build/posix/resolv.h b/headers/build/posix/resolv.h
new file mode 100644
index 0000000..4f8c6ae
--- /dev/null
+++ b/headers/build/posix/resolv.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_RESOLV_H
+#define _HAIKU_BUILD_RESOLV_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <resolv.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_RESOLV_H */
diff --git a/headers/build/posix/sched.h b/headers/build/posix/sched.h
new file mode 100644
index 0000000..093735c
--- /dev/null
+++ b/headers/build/posix/sched.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SCHED_H
+#define _HAIKU_BUILD_SCHED_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <sched.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SCHED_H */
diff --git a/headers/build/posix/search.h b/headers/build/posix/search.h
new file mode 100644
index 0000000..f83b754
--- /dev/null
+++ b/headers/build/posix/search.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SEARCH_H
+#define _HAIKU_BUILD_SEARCH_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <search.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SEARCH_H */
diff --git a/headers/build/posix/semaphore.h b/headers/build/posix/semaphore.h
new file mode 100644
index 0000000..5d4bae1
--- /dev/null
+++ b/headers/build/posix/semaphore.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SEMAPHORE_H
+#define _HAIKU_BUILD_SEMAPHORE_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <semaphore.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SEMAPHORE_H */
diff --git a/headers/build/posix/setjmp.h b/headers/build/posix/setjmp.h
new file mode 100644
index 0000000..c7ce3b1
--- /dev/null
+++ b/headers/build/posix/setjmp.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SETJMP_H
+#define _HAIKU_BUILD_SETJMP_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <setjmp.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SETJMP_H */
diff --git a/headers/build/posix/shadow.h b/headers/build/posix/shadow.h
new file mode 100644
index 0000000..1b69939
--- /dev/null
+++ b/headers/build/posix/shadow.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SHADOW_H
+#define _HAIKU_BUILD_SHADOW_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <shadow.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SHADOW_H */
diff --git a/headers/build/posix/signal.h b/headers/build/posix/signal.h
new file mode 100644
index 0000000..9556bce
--- /dev/null
+++ b/headers/build/posix/signal.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SIGNAL_H
+#define _HAIKU_BUILD_SIGNAL_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <signal.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SIGNAL_H */
diff --git a/headers/build/posix/size_t.h b/headers/build/posix/size_t.h
new file mode 100644
index 0000000..aeddf6b
--- /dev/null
+++ b/headers/build/posix/size_t.h
@@ -0,0 +1,25 @@
+/*
+ * Copyright 2008-2011 Haiku Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_SIZE_T_H
+#define _HAIKU_BUILD_SIZE_T_H
+
+
+#include <stddef.h>
+
+
+/* ATM we don't define ssize_t for GCC2 */
+#if __GNUC__ > 2 /*&& !defined(__ssize_t__)*/
+/*#	define __ssize_t__*/
+typedef long signed int	haiku_build_ssize_t;
+#endif
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+// not a standard header.
+//#	include_next <size_t.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_SIZE_T_H */
diff --git a/headers/build/posix/stdint.h b/headers/build/posix/stdint.h
new file mode 100644
index 0000000..259d22e
--- /dev/null
+++ b/headers/build/posix/stdint.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_STDINT_H
+#define _HAIKU_BUILD_STDINT_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <stdint.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_STDINT_H */
diff --git a/headers/build/posix/stdio.h b/headers/build/posix/stdio.h
new file mode 100644
index 0000000..83fc0e6
--- /dev/null
+++ b/headers/build/posix/stdio.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_STDIO_H
+#define _HAIKU_BUILD_STDIO_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <stdio.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_STDIO_H */
diff --git a/headers/build/posix/stdlib.h b/headers/build/posix/stdlib.h
new file mode 100644
index 0000000..dab098a
--- /dev/null
+++ b/headers/build/posix/stdlib.h
@@ -0,0 +1,14 @@
+/*
+ * Copyright 2011, Haiku, Inc. All Rights Reserved.
+ * Distributed under the terms of the MIT License.
+ */
+#ifndef _HAIKU_BUILD_STDLIB_H
+#define _HAIKU_BUILD_STDLIB_H
+
+
+#ifdef _HAIKU_BUILD_LIBROOT_FUNCTION_WRAPPER
+#	include_next <stdlib.h>
+#endif
+
+
+#endif	/* _HAIKU_BUILD_STDLIB_H */
